
//float4 lightSource;
//float Factor = 3.141592654;
float4 drawPos;

// Texture to be drawn
Texture g_Tex;
sampler2D s = sampler_state {
	Texture = <g_Tex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// Mask Map
Texture g_Map;
sampler2D DM = sampler_state {
	Texture = <g_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// Height Map
Texture h_Map;
sampler2D HM = sampler_state {
	Texture = <h_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




float4 water ( float2 texCoords : TEXCOORD0 ) : COLOR
{
    float fac = 0.2*tex2D(DM, texCoords).x;
    if(fac != 0.0) {
        float dx = tex2D(HM, texCoords+float2(0.001,0)).x - tex2D(HM, texCoords).x;
        float dy = tex2D(HM, texCoords+float2(0,0.001)).x - tex2D(HM, texCoords).x;
        float ddx = dx-0.2;
        float ddy = dy-0.55;
        float dd = ddx*ddx + ddy*ddy;
        fac *= 3;
        if(dd < 0.32) {
            float4 col = (1-fac)*tex2D(s, texCoords + float2(fac*dx,fac*dy)) + fac*float4(0.01,0.023,0.1,1.0);
            dd = (0.32-dd)*10;
            if (dd<0.0)
                dd = 0.0;
            else
                if (dd>fac)
                    dd = fac;
            //return float4(dd,0,0,1);
            return col*(1-dd) + dd*float4(1,1,1,1);
        } else {
            return (1-fac)*tex2D(s, texCoords + float2(fac*dx,fac*dy)) + fac*float4(0.01,0.023,0.1,1.0);
        }
    }
    return tex2D(s, texCoords);
}





technique Water
{
	pass p0
	{
		Sampler[0] = <s>;
		Sampler[1] = <DM>;
		Sampler[2] = <HM>;
		PixelShader = compile ps_2_0 water();
	}
}
